<configuration>

    <appender name="STDOUT" class="ch.qos.logback.core.ConsoleAppender">
        <encoder>
            <pattern>%d [%thread] %-5level %logger{36} - %msg%n</pattern>
        </encoder>
    </appender>

    <property name="pipeAppender" value="${PIVEAU_PIPE_LOG_APPENDER:-STDOUT}" />

    <if condition='property("pipeAppender").equals("LOGSTASH")'>
        <then>
            <appender name="LOGSTASH" class="net.logstash.logback.appender.LogstashTcpSocketAppender">
                <destination>${PIVEAU_LOGSTASH_HOST:-logstash}:${PIVEAU_LOGSTASH_PORT:-5044}</destination>
                <encoder class="net.logstash.logback.encoder.LogstashEncoder" />
            </appender>
        </then>
    </if>
    <if condition='property("pipeAppender").equals("PIPEFILE")'>
        <then>
            <appender name="PIPEFILE" class="ch.qos.logback.core.rolling.RollingFileAppender">
                <prudent>true</prudent>
                <rollingPolicy class="ch.qos.logback.core.rolling.TimeBasedRollingPolicy">
                    <!-- daily rollover -->
                    <fileNamePattern>${PIVEAU_PIPE_LOG_PATH:-logs/piveau-pipe.%d{yyyy-MM-dd}.log}</fileNamePattern>

                    <!-- keep 30 days' worth of history capped at 3GB total size -->
                    <maxHistory>10</maxHistory>
                    <totalSizeCap>1GB</totalSizeCap>

                </rollingPolicy>
                <encoder>
                    <pattern>[%d{yyyy-MM-dd HH:mm:ss.SSS}] %-5level %logger %msg%n</pattern>
                </encoder>
            </appender>
        </then>
    </if>

    <logger name="com.mchange.v2" level="warn"/>
    <logger name="io.netty" level="warn"/>
    <logger name="io.vertx" level="info"/>
    <logger name="io.piveau" level="${PIVEAU_LOG_LEVEL:-INFO}"/>

    <logger name="pipe" level="${PIVEAU_PIPE_LOG_LEVEL:-INFO}" additivity="false">
        <appender-ref ref="${pipeAppender}" />
    </logger>

    <root level="info">
        <appender-ref ref="STDOUT" />
    </root>

</configuration>
